## org.apache.poi.hssf.record
Class NumberRecord

    java.lang.Object
      org.apache.poi.hssf.record.Record
          org.apache.poi.hssf.record.NumberRecord

All Implemented Interfaces:
  CellValueRecordInterface, java.lang.Comparable

public class NumberRecord
extends Record
implements CellValueRecordInterface, java.lang.Comparable

Contains a numeric cell value.

REFERENCE: PG 334 Microsoft Excel 97 Developer's Kit (ISBN: 1-57231-498-2)

Version:
  2.0-pre
Author:
  Andrew C. Oliver (acoliver at apache dot org), Jason Height (jheight at chariot dot net dot au)

Field Summary
`static short` `sid`

Constructor Summary
`NumberRecord()` Creates new NumberRecord
`NumberRecord(short id, short size, byte[] data)` Constructs a Number record and sets its fields appropriately.
`NumberRecord(short id, short size, byte[] data, int offset)` Constructs a Number record and sets its fields appropriately.

Method Summary
`java.lang.Object` `clone()`
`int` `compareTo(java.lang.Object obj)`
`boolean` `equals(java.lang.Object obj)`
`protected void` `fillFields(byte[] data, short size, int offset)` called by the constructor, should set class level fields.
`short` `getColumn()` get the column this cell defines within the row
`int` `getRecordSize()` gives the current serialized size of the record.
`int` `getRow()` get the row this cell occurs on
`short` `getSid()` return the non static version of the id for this record.
`double` `getValue()` get the value for the cell
`short` `getXFIndex()` get the index to the ExtendedFormat
`boolean` `isAfter(CellValueRecordInterface i)` returns whether this cell is after the passed in cell
`boolean` `isBefore(CellValueRecordInterface i)` returns whether this cell is before the passed in cell
`boolean` `isEqual(CellValueRecordInterface i)` returns whether this cell represents the same cell (NOT VALUE)
`boolean` `isInValueSection()` DBCELL, ROW, VALUES all say yes
`boolean` `isValue()` tells whether this type of record contains a value
`int` `serialize(int offset, byte[] data)` called by the class that is responsible for writing this sucker.
`void` `setColumn(short col)` set the column this cell defines within the row
`void` `setRow(int row)` set the row this cell occurs on
`void` `setValue(double value)` set the value for the cell
`void` `setXFIndex(short xf)` set the index to the ExtendedFormat
`java.lang.String` `toString()` get a string representation of the record (for biffview/debugging)
`protected void` `validateSid(short id)` called by constructor, should throw runtime exception in the event of a record passed with a differing ID.

Methods inherited from class org.apache.poi.hssf.record.Record
`fillFields, processContinueRecord, serialize`

Methods inherited from class java.lang.Object
`finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### sid

    public static final short sid

See Also:
  Constant Field Values

Constructor Detail

### NumberRecord

    public NumberRecord()

  Creates new NumberRecord

### NumberRecord

    public NumberRecord(short id,
                        short size,
                        byte[] data)

  Constructs a Number record and sets its fields appropriately.

Parameters:
  `id` - id must be 0x203 or an exception will be throw upon validation
  `size` - the size of the data area of the record
  `data` - data of the record (should not contain sid/len)

### NumberRecord

    public NumberRecord(short id,
                        short size,
                        byte[] data,
                        int offset)

  Constructs a Number record and sets its fields appropriately.

Parameters:
  `id` - id must be 0x203 or an exception will be throw upon validation
  `size` - the size of the data area of the record
  `data` - data of the record (should not contain sid/len)
  `offset` - of the data

Method Detail

### fillFields

    protected void fillFields(byte[] data,
                              short size,
                              int offset)

  called by the constructor, should set class level fields. Should throw runtime exception for bad/icomplete data.

  Specified by:
    `fillFields` in class `Record`
  Parameters:
    `data` - raw data
    `size` - size of data
    `offset` - of the record's data (provided a big array of the file)

### setRow

    public void setRow(int row)

  Description copied from interface: `CellValueRecordInterface`
  set the row this cell occurs on

  Specified by:
    `setRow` in interface `CellValueRecordInterface`
  Parameters:
    `row` - the row this cell occurs within

### setColumn

    public void setColumn(short col)

  Description copied from interface: `CellValueRecordInterface`
  set the column this cell defines within the row

  Specified by:
    `setColumn` in interface `CellValueRecordInterface`
  Parameters:
    `col` - the column this cell defines

### setXFIndex

    public void setXFIndex(short xf)

  set the index to the ExtendedFormat

  Specified by:
    `setXFIndex` in interface `CellValueRecordInterface`
  Parameters:
    `xf` - index to the XF record
  See Also:
    `ExtendedFormatRecord`

### setValue

    public void setValue(double value)

  set the value for the cell

  Parameters:
    `value` - double representing the value

### getRow

    public int getRow()

  Description copied from interface: `CellValueRecordInterface`
  get the row this cell occurs on

  Specified by:
    `getRow` in interface `CellValueRecordInterface`
  Returns:
    the row

### getColumn

    public short getColumn()

  Description copied from interface: `CellValueRecordInterface`
  get the column this cell defines within the row

  Specified by:
    `getColumn` in interface `CellValueRecordInterface`
  Returns:
    the column

### getXFIndex

    public short getXFIndex()

  get the index to the ExtendedFormat

  Specified by:
    `getXFIndex` in interface `CellValueRecordInterface`
  Returns:
    index to the XF record
  See Also:
    `ExtendedFormatRecord`

### getValue

    public double getValue()

  get the value for the cell

  Returns:
    double representing the value

### toString

    public java.lang.String toString()

  Description copied from class: `Record`
  get a string representation of the record (for biffview/debugging)

  Overrides:
    `toString` in class `Record`

### serialize

    public int serialize(int offset,
                         byte[] data)

  called by the class that is responsible for writing this sucker. Subclasses should implement this so that their data is passed back in a byte array.

  Specified by:
    `serialize` in class `Record`
  Parameters:
    `offset` - to begin writing at
    `data` - byte array containing instance data
  Returns:
    byte array containing instance data

### getRecordSize

    public int getRecordSize()

  Description copied from class: `Record`
  gives the current serialized size of the record. Should include the sid and reclength (4 bytes).

  Overrides:
    `getRecordSize` in class `Record`

### validateSid

    protected void validateSid(short id)

  called by constructor, should throw runtime exception in the event of a record passed with a differing ID.

  Specified by:
    `validateSid` in class `Record`
  Parameters:
    `id` - alleged id for this record

### getSid

    public short getSid()

  Description copied from class: `Record`
  return the non static version of the id for this record.

  Specified by:
    `getSid` in class `Record`

### isBefore

    public boolean isBefore(CellValueRecordInterface i)

  Description copied from interface: `CellValueRecordInterface`
  returns whether this cell is before the passed in cell

  Specified by:
    `isBefore` in interface `CellValueRecordInterface`
  Parameters:
    `i` - another cell interface record to compare
  Returns:
    true if the cells is before, or false if not

### isAfter

    public boolean isAfter(CellValueRecordInterface i)

  Description copied from interface: `CellValueRecordInterface`
  returns whether this cell is after the passed in cell

  Specified by:
    `isAfter` in interface `CellValueRecordInterface`
  Parameters:
    `i` - record to compare
  Returns:
    true if the cell is after, false if not

### isEqual

    public boolean isEqual(CellValueRecordInterface i)

  Description copied from interface: `CellValueRecordInterface`
  returns whether this cell represents the same cell (NOT VALUE)

  Specified by:
    `isEqual` in interface `CellValueRecordInterface`
  Parameters:
    `i` - record to compare
  Returns:
    true if the cells are the same cell (positionally), false if not.

### isInValueSection

    public boolean isInValueSection()

  Description copied from class: `Record`
  DBCELL, ROW, VALUES all say yes

  Overrides:
    `isInValueSection` in class `Record`

### isValue

    public boolean isValue()

  Description copied from class: `Record`
  tells whether this type of record contains a value

  Overrides:
    `isValue` in class `Record`

### compareTo

    public int compareTo(java.lang.Object obj)

  Specified by:
    `compareTo` in interface `java.lang.Comparable`

### equals

    public boolean equals(java.lang.Object obj)

### clone

    public java.lang.Object clone()

  Specified by:
    `clone` in interface `CellValueRecordInterface`
  Overrides:
    `clone` in class `Record`

Copyright © 2003 Apache Software Foundation.